Index: trunk/source/persistency/gdml/include/G4GDMLWriteParamvol.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWriteParamvol.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWriteParamvol.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteParamvol.hh,v 1.10 2008/08/13 13:58:53 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteParamvol.hh,v 1.13 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,17 +42,32 @@
 #define _G4GDMLWRITEPARAMVOL_INCLUDED_
 
-#include "G4PVParameterised.hh"
-#include "G4VPhysicalVolume.hh"
+#include "G4GDMLWriteSetup.hh"
 
-#include "G4GDMLWriteSetup.hh"
+class G4Box;
+class G4Trd;
+class G4Trap;
+class G4Tubs;
+class G4Cons;
+class G4Sphere;
+class G4Orb;
+class G4Torus;
+class G4Para;
+class G4Hype;
+class G4VPhysicalVolume;
 
 class G4GDMLWriteParamvol : public G4GDMLWriteSetup
 {
 
+ public:
+
+   virtual void ParamvolWrite(xercesc::DOMElement*,
+                              const G4VPhysicalVolume* const);
+   virtual void ParamvolAlgorithmWrite(xercesc::DOMElement* paramvolElement,
+                              const G4VPhysicalVolume* const paramvol);
+
  protected:
 
-   void ParamvolWrite(xercesc::DOMElement*, const G4VPhysicalVolume* const);
-
- private:
+   G4GDMLWriteParamvol();
+   virtual ~G4GDMLWriteParamvol();
 
    void Box_dimensionsWrite(xercesc::DOMElement*, const G4Box* const);
@@ -68,6 +83,4 @@
    void ParametersWrite(xercesc::DOMElement*,
                         const G4VPhysicalVolume* const, const G4int&);
-   void ParamvolAlgorithmWrite(xercesc::DOMElement* paramvolElement,
-                               const G4VPhysicalVolume* const paramvol);
 
 };
Index: trunk/source/persistency/gdml/include/G4GDMLWriteSetup.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWriteSetup.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWriteSetup.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteSetup.hh,v 1.7 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteSetup.hh,v 1.9 2009/04/15 13:29:30 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -46,7 +46,13 @@
 class G4GDMLWriteSetup : public G4GDMLWriteSolids
 {
- private:
+  public:
 
-   void SetupWrite(xercesc::DOMElement*, const G4LogicalVolume* const);
+    virtual void SetupWrite(xercesc::DOMElement*, const G4LogicalVolume* const);
+
+ protected:
+
+   G4GDMLWriteSetup();
+   virtual ~G4GDMLWriteSetup();
+
 };
 
Index: trunk/source/persistency/gdml/include/G4GDMLWriteSolids.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWriteSolids.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWriteSolids.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteSolids.hh,v 1.32 2008/11/21 09:32:46 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteSolids.hh,v 1.38 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,43 +42,46 @@
 #define _G4GDMLWRITESOLIDS_INCLUDED_
 
-#include "G4BooleanSolid.hh"
-#include "G4Box.hh"
-#include "G4Cons.hh"
-#include "G4Ellipsoid.hh"
-#include "G4EllipticalCone.hh"
-#include "G4EllipticalTube.hh"
-#include "G4ExtrudedSolid.hh"
-#include "G4Hype.hh"
-#include "G4Orb.hh"
-#include "G4Para.hh"
-#include "G4Paraboloid.hh"
-#include "G4IntersectionSolid.hh"
-#include "G4Polycone.hh"
-#include "G4Polyhedra.hh"
-#include "G4ReflectedSolid.hh"
-#include "G4Sphere.hh"
-#include "G4SubtractionSolid.hh"
-#include "G4TessellatedSolid.hh"
-#include "G4Tet.hh"
-#include "G4Torus.hh"
-#include "G4Trap.hh"
-#include "G4Trd.hh"
-#include "G4Tubs.hh"
-#include "G4TwistedBox.hh"
-#include "G4TwistedTrap.hh"
-#include "G4TwistedTrd.hh"
-#include "G4TwistedTubs.hh"
-#include "G4UnionSolid.hh"
+#include "G4Types.hh"
 
 #include "G4GDMLWriteMaterials.hh"
 
+class G4BooleanSolid;
+class G4Box;
+class G4Cons;
+class G4EllipticalCone;
+class G4Ellipsoid;
+class G4EllipticalTube;
+class G4ExtrudedSolid;
+class G4Hype;
+class G4Orb;
+class G4Para;
+class G4Paraboloid;
+class G4Polycone;
+class G4Polyhedra;
+class G4Sphere;
+class G4TessellatedSolid;
+class G4Tet;
+class G4Torus;
+class G4Trap;
+class G4Trd;
+class G4Tubs;
+class G4TwistedBox;
+class G4TwistedTrap;
+class G4TwistedTrd;
+class G4TwistedTubs;
+class G4VSolid;
+class G4OpticalSurface;
+
 class G4GDMLWriteSolids : public G4GDMLWriteMaterials
 {
+  public:
 
- protected:
+   virtual void AddSolid(const G4VSolid* const);
+   virtual void SolidsWrite(xercesc::DOMElement*);
 
-   void AddSolid(const G4VSolid* const);
+  protected:
 
- private:
+   G4GDMLWriteSolids();
+   virtual ~G4GDMLWriteSolids();
 
    void BooleanWrite(xercesc::DOMElement*, const G4BooleanSolid* const);
@@ -108,10 +111,14 @@
    void ZplaneWrite(xercesc::DOMElement*, const G4double&,
                     const G4double&, const G4double&);
-   void SolidsWrite(xercesc::DOMElement*);
+   void OpticalSurfaceWrite(xercesc::DOMElement*,
+                    const G4OpticalSurface* const);
 
- private:
+  protected:
 
    std::vector<const G4VSolid*> solidList;
    xercesc::DOMElement* solidsElement;
+   static const G4int maxTransforms = 8; // Constant for limiting the number
+                                         // of displacements/reflections
+                                         // applied to a single solid
 };
 
Index: trunk/source/persistency/gdml/include/G4GDMLWriteStructure.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWriteStructure.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWriteStructure.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteStructure.hh,v 1.34 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteStructure.hh,v 1.39 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,34 +42,51 @@
 #define _G4GDMLWRITESTRUCTURE_INCLUDED_
 
-#include "G4LogicalVolumeStore.hh"
-#include "G4PhysicalVolumeStore.hh"
-#include "G4Material.hh"
-#include "G4PVDivision.hh"
-#include "G4PVReplica.hh"
-#include "G4VPhysicalVolume.hh"
-#include "G4ReflectedSolid.hh"
+#include "G4Types.hh"
 #include "G4Transform3D.hh"
 
 #include "G4GDMLWriteParamvol.hh"
 
+class G4LogicalVolume;
+class G4VPhysicalVolume;
+class G4PVDivision;
+class G4LogicalBorderSurface;
+class G4LogicalSkinSurface;
+class G4OpticalSurface;
+class G4SurfaceProperty;
+
 class G4GDMLWriteStructure : public G4GDMLWriteParamvol
 {
 
- private:
+ public:
 
-   void DivisionvolWrite(xercesc::DOMElement*,const G4PVDivision* const);
+   G4GDMLWriteStructure();
+   virtual ~G4GDMLWriteStructure();
+
+   virtual void StructureWrite(xercesc::DOMElement*);
+
+ protected:
+
+   void DivisionvolWrite(xercesc::DOMElement*, const G4PVDivision* const);
    void PhysvolWrite(xercesc::DOMElement*,const G4VPhysicalVolume* const topVol,
-                                          const G4Transform3D& transform,
-                                          const G4String& moduleName);
-   void ReplicavolWrite(xercesc::DOMElement*,const G4VPhysicalVolume* const);
-   void StructureWrite(xercesc::DOMElement*);
+                   const G4Transform3D& transform, const G4String& moduleName);
+   void ReplicavolWrite(xercesc::DOMElement*, const G4VPhysicalVolume* const);
    G4Transform3D TraverseVolumeTree(const G4LogicalVolume* const topVol,
                                     const G4int depth);
- private:
+   void SurfacesWrite();
+   void BorderSurfaceCache(const G4LogicalBorderSurface* const);
+   void SkinSurfaceCache(const G4LogicalSkinSurface* const);
+   const G4LogicalBorderSurface* GetBorderSurface(const G4VPhysicalVolume* const);
+   const G4LogicalSkinSurface* GetSkinSurface(const G4LogicalVolume* const);
+   G4bool FindOpticalSurface(const G4SurfaceProperty*);
+
+ protected:
 
    xercesc::DOMElement* structureElement;
-   static const int maxReflections = 8; // Constant for limiting the number
-                                        // of displacements/reflections applied
-                                        // to a single solid
+   std::vector<xercesc::DOMElement*> borderElementVec;
+   std::vector<xercesc::DOMElement*> skinElementVec;
+
+ private:  // cache for optical surfaces...
+
+   std::vector<const G4OpticalSurface*> opt_vec;
 };
 
Index: trunk/source/persistency/gdml/include/G4STRead.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4STRead.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4STRead.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4STRead.hh,v 1.3 2008/07/17 14:05:50 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4STRead.hh,v 1.4 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -44,15 +44,13 @@
 #define _G4STREAD_INCLUDED_
 
-#include <fstream>
 #include <vector>
 #include <map>
 
-#include "G4TessellatedSolid.hh"
-#include "G4QuadrangularFacet.hh"
-#include "G4TriangularFacet.hh"
-#include "G4LogicalVolume.hh"
-#include "G4PVPlacement.hh"
-#include "G4Material.hh"
-#include "G4Box.hh"
+#include "G4ThreeVector.hh"
+
+class G4Material;
+class G4Box;
+class G4TessellatedSolid;
+class G4LogicalVolume;
 
 class G4STRead
Index: trunk/source/persistency/gdml/src/G4GDMLEvaluator.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLEvaluator.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLEvaluator.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4GDMLEvaluator.cc,v 1.22 2009/02/26 10:13:35 gcosmo Exp $
+// $Id: G4GDMLEvaluator.cc,v 1.23 2009/04/24 15:34:20 gcosmo Exp $
 // GEANT4 tag $ Name:$
 //
@@ -35,4 +35,7 @@
 
 #include <sstream>
+
+#include "globals.hh"
+
 #include "G4GDMLEvaluator.hh"
 
Index: trunk/source/persistency/gdml/src/G4GDMLParameterisation.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLParameterisation.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLParameterisation.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4GDMLParameterisation.cc,v 1.11 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLParameterisation Implementation
Index: trunk/source/persistency/gdml/src/G4GDMLParser.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLParser.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLParser.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLParser.cc,v 1.13 2008/11/20 15:33:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4GDMLParser.cc,v 1.14 2009/04/15 13:29:30 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -36,5 +36,5 @@
 
 G4GDMLParser::G4GDMLParser()
-  : ucode(false)
+  : urcode(false), uwcode(false)
 {
   reader = new G4GDMLReadStructure;
@@ -43,9 +43,18 @@
 }
 
-G4GDMLParser::G4GDMLParser(G4GDMLReadStructure* ext)
-  : ucode(true)
+G4GDMLParser::G4GDMLParser(G4GDMLReadStructure* extr)
+  : urcode(true), uwcode(false)
 {
-  reader = ext;
+  reader = extr;
   writer = new G4GDMLWriteStructure;
+  xercesc::XMLPlatformUtils::Initialize();
+}
+
+G4GDMLParser::G4GDMLParser(G4GDMLReadStructure* extr,
+                           G4GDMLWriteStructure* extw)
+  : urcode(true), uwcode(true)
+{
+  reader = extr;
+  writer = extw;
   xercesc::XMLPlatformUtils::Initialize();
 }
@@ -54,5 +63,5 @@
 {
   xercesc::XMLPlatformUtils::Terminate();
-  delete writer;
-  if (!ucode) { delete reader; }
+  if (!urcode) { delete reader; }
+  if (!uwcode) { delete writer; }
 }
Index: trunk/source/persistency/gdml/src/G4GDMLRead.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLRead.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLRead.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GDMLRead.cc,v 1.41 2009/01/22 11:02:07 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLRead.cc,v 1.47 2009/05/12 15:46:43 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLRead Implementation
@@ -33,5 +33,9 @@
 // -------------------------------------------------------------------------
 
+#include "globals.hh"
+
 #include "G4GDMLRead.hh"
+
+#include "G4UnitsTable.hh"
 #include "G4Element.hh"
 #include "G4Material.hh"
@@ -39,8 +43,7 @@
 #include "G4LogicalVolumeStore.hh"
 #include "G4PhysicalVolumeStore.hh"
-#include "G4UnitsTable.hh"
 
 G4GDMLRead::G4GDMLRead()
-  : validate(true), check(false)
+  : validate(true), check(false), inLoop(0), loopCount(0)
 {
    G4UnitDefinition::BuildUnitsTable();
@@ -68,5 +71,11 @@
    G4String nameOut(nameIn);
 
-   if (inLoop>0) { nameOut = eval.SolveBrackets(nameOut); }
+   if (inLoop>0)
+   {
+     nameOut = eval.SolveBrackets(nameOut);
+//     std::stringstream stream;
+//     stream << "0x" << loopCount;
+//     nameOut = nameOut + stream.str();
+   }
    if (strip) { StripName(nameOut); }
 
@@ -235,14 +244,15 @@
 
    inLoop++;
-   
+
    while (_var <= _to)
    {
       eval.SetVariable(var,_var);
       (this->*func)(element);
-
       _var += _step;
+      loopCount++;
    }
 
    inLoop--;
+   if (!inLoop) { loopCount = 0; }
 }
 
Index: trunk/source/persistency/gdml/src/G4GDMLReadDefine.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLReadDefine.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLReadDefine.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GDMLReadDefine.cc,v 1.20 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadDefine.cc,v 1.24 2009/10/14 13:10:18 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLReadDefine Implementation
@@ -36,12 +36,15 @@
 
 G4GDMLMatrix::G4GDMLMatrix()
-{
-   rows = 0;
-   cols = 0;
-   m = 0;
-}
-
-G4GDMLMatrix::G4GDMLMatrix(size_t rows0,size_t cols0)
+  : m(0), rows(0), cols(0)
+{
+}
+
+G4GDMLMatrix::G4GDMLMatrix(size_t rows0, size_t cols0)
 {   
+   if ((rows<=0) || (cols<=0))
+   {
+     G4Exception("G4GDMLMatrix::G4GDMLMatrix(r,c)", "InvalidSetup",
+                 FatalException, "Zero indeces as arguments!?");
+   }
    rows = rows0;
    cols = cols0;
@@ -49,7 +52,42 @@
 }
 
+G4GDMLMatrix::G4GDMLMatrix(const G4GDMLMatrix& rhs)
+  : m(0), rows(0), cols(0)
+{
+   if (rhs.m)
+   {
+     rows = rhs.rows;
+     cols = rhs.cols;
+     m = new G4double[rows*cols];
+     for (size_t i=0; i<rows*cols; i++)  { m[i] = rhs.m[i]; }
+   }
+}
+
+G4GDMLMatrix& G4GDMLMatrix::operator=(const G4GDMLMatrix& rhs)
+{
+   // Check assignment to self
+   //
+   if (this == &rhs)  { return *this; }
+
+   // Copy data
+   //
+   rows = rhs.rows;
+   cols = rhs.cols;
+   if (rhs.m)
+   {
+     m = new G4double[rows*cols];
+     for (size_t i=0; i<rows*cols; i++)  { m[i] = rhs.m[i]; }
+   }
+   else
+   {
+     m = 0;
+   }
+
+   return *this;
+}
+
 G4GDMLMatrix::~G4GDMLMatrix()
 {
-   if (m) { delete [] m; }
+   delete [] m;
 }
 
@@ -84,4 +122,12 @@
 }
 
+G4GDMLReadDefine::G4GDMLReadDefine() : G4GDMLRead()
+{
+}
+
+G4GDMLReadDefine::~G4GDMLReadDefine()
+{
+}
+
 G4RotationMatrix
 G4GDMLReadDefine::GetRotationMatrix(const G4ThreeVector& angles)
@@ -122,4 +168,34 @@
    }
 
+   eval.DefineConstant(name,value);
+}
+
+void
+G4GDMLReadDefine::ExpressionRead(const xercesc::DOMElement* const expElement)
+{
+   G4String name  = "";
+   G4double value = 0.0;
+
+   const xercesc::DOMNamedNodeMap* const attributes
+         = expElement->getAttributes();
+   XMLSize_t attributeCount = attributes->getLength();
+
+   for (XMLSize_t attribute_index=0;
+        attribute_index<attributeCount; attribute_index++)
+   {
+      xercesc::DOMNode* node = attributes->item(attribute_index);
+
+      if (node->getNodeType() != xercesc::DOMNode::ATTRIBUTE_NODE) { continue; }
+
+      const xercesc::DOMAttr* const attribute
+            = dynamic_cast<xercesc::DOMAttr*>(node);   
+      const G4String attName = Transcode(attribute->getName());
+      const G4String attValue = Transcode(attribute->getValue());
+
+      if (attName=="name")  { name = attValue; }
+   }
+
+   const G4String expValue = Transcode(expElement->getTextContent());
+   value = eval.Evaluate(expValue);
    eval.DefineConstant(name,value);
 }
@@ -328,4 +404,5 @@
 
    quantityMap[name] = value*unit;
+   eval.DefineConstant(name,value*unit);
 }
 
@@ -350,5 +427,6 @@
       if (tag=="scale")    { ScaleRead(child); }    else
       if (tag=="variable") { VariableRead(child); } else
-      if (tag=="quantity") { QuantityRead(child); }
+      if (tag=="quantity") { QuantityRead(child); } else
+      if (tag=="expression") { ExpressionRead(child); }
       else
       {
Index: trunk/source/persistency/gdml/src/G4GDMLReadMaterials.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLReadMaterials.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLReadMaterials.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4GDMLReadMaterials.cc,v 1.16 2008/08/22 10:00:20 gcosmo Exp $
+// $Id: G4GDMLReadMaterials.cc,v 1.20 2009/04/24 15:34:20 gcosmo Exp $
 // GEANT4 tag $ Name:$
 //
@@ -35,4 +35,17 @@
 
 #include "G4GDMLReadMaterials.hh"
+
+#include "G4Element.hh"
+#include "G4Isotope.hh"
+#include "G4Material.hh"
+#include "G4NistManager.hh"
+
+G4GDMLReadMaterials::G4GDMLReadMaterials() : G4GDMLReadDefine()
+{
+}
+
+G4GDMLReadMaterials::~G4GDMLReadMaterials()
+{
+}
 
 G4double
@@ -497,16 +510,23 @@
    if (matrix.GetRows() == 0) { return; }
 
-   G4MaterialPropertiesTable* matprop = material->GetMaterialPropertiesTable();
+   G4MaterialPropertiesTable* matprop=material->GetMaterialPropertiesTable();
    if (!matprop)
    {
-     material->SetMaterialPropertiesTable(
-               matprop = new G4MaterialPropertiesTable());
-   }
-   G4MaterialPropertyVector* propvect = new G4MaterialPropertyVector(0,0,0);
-   for (size_t i=0; i<matrix.GetRows(); i++)
-   {
-     propvect->AddElement(matrix.Get(i,0),matrix.Get(i,1));
-   }
-   matprop->AddProperty(Strip(name),propvect);
+     matprop = new G4MaterialPropertiesTable();
+     material->SetMaterialPropertiesTable(matprop);
+   }
+   if (matrix.GetCols() == 1)  // constant property assumed
+   {
+     matprop->AddConstProperty(Strip(name), matrix.Get(0,0));
+   }
+   else  // build the material properties vector
+   {
+     G4MaterialPropertyVector* propvect = new G4MaterialPropertyVector(0,0,0);
+     for (size_t i=0; i<matrix.GetRows(); i++)
+     {
+       propvect->AddElement(matrix.Get(i,0),matrix.Get(i,1));
+     }
+     matprop->AddProperty(Strip(name),propvect);
+   }
 }
 
@@ -524,5 +544,6 @@
             = dynamic_cast<xercesc::DOMElement*>(iter);
       const G4String tag = Transcode(child->getTagName());
-
+      
+      if (tag=="define")   { DefineRead(child);  }  else 
       if (tag=="element")  { ElementRead(child); }  else 
       if (tag=="isotope")  { IsotopeRead(child); }  else 
Index: trunk/source/persistency/gdml/src/G4GDMLReadParamvol.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLReadParamvol.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLReadParamvol.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GDMLReadParamvol.cc,v 1.11 2009/01/22 11:02:07 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadParamvol.cc,v 1.13 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLReadParamvol Implementation
@@ -34,4 +34,17 @@
 
 #include "G4GDMLReadParamvol.hh"
+
+#include "G4LogicalVolume.hh"
+#include "G4PVParameterised.hh"
+#include "G4PVPlacement.hh"
+#include "G4VPhysicalVolume.hh"
+
+G4GDMLReadParamvol::G4GDMLReadParamvol() : G4GDMLReadSetup()
+{
+}
+
+G4GDMLReadParamvol::~G4GDMLReadParamvol()
+{
+}
 
 void G4GDMLReadParamvol::
Index: trunk/source/persistency/gdml/src/G4GDMLReadSetup.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLReadSetup.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLReadSetup.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GDMLReadSetup.cc,v 1.9 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadSetup.cc,v 1.10 2009/03/24 15:47:33 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLReadSetup Implementation
@@ -34,4 +34,12 @@
 
 #include "G4GDMLReadSetup.hh"
+
+G4GDMLReadSetup::G4GDMLReadSetup() : G4GDMLReadSolids()
+{
+}
+
+G4GDMLReadSetup::~G4GDMLReadSetup()
+{
+}
 
 G4String G4GDMLReadSetup::GetSetup(const G4String& ref)
Index: trunk/source/persistency/gdml/src/G4GDMLReadSolids.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLReadSolids.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLReadSolids.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GDMLReadSolids.cc,v 1.22 2008/11/21 09:32:46 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadSolids.cc,v 1.27 2009/12/04 13:58:51 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLReadSolids Implementation
@@ -34,4 +34,45 @@
 
 #include "G4GDMLReadSolids.hh"
+
+#include "G4Box.hh"
+#include "G4Cons.hh"
+#include "G4Ellipsoid.hh"
+#include "G4EllipticalCone.hh"
+#include "G4EllipticalTube.hh"
+#include "G4Hype.hh"
+#include "G4IntersectionSolid.hh"
+#include "G4Orb.hh"
+#include "G4Para.hh"
+#include "G4Paraboloid.hh"
+#include "G4Polycone.hh"
+#include "G4Polyhedra.hh"
+#include "G4QuadrangularFacet.hh"
+#include "G4ReflectedSolid.hh"
+#include "G4Sphere.hh"
+#include "G4SolidStore.hh"
+#include "G4SubtractionSolid.hh"
+#include "G4TessellatedSolid.hh"
+#include "G4Tet.hh"
+#include "G4Torus.hh"
+#include "G4Transform3D.hh"
+#include "G4Trap.hh"
+#include "G4Trd.hh"
+#include "G4TriangularFacet.hh"
+#include "G4Tubs.hh"
+#include "G4TwistedBox.hh"
+#include "G4TwistedTrap.hh"
+#include "G4TwistedTrd.hh"
+#include "G4TwistedTubs.hh"
+#include "G4UnionSolid.hh"
+#include "G4OpticalSurface.hh"
+#include "G4SurfaceProperty.hh"
+
+G4GDMLReadSolids::G4GDMLReadSolids() : G4GDMLReadMaterials()
+{
+}
+
+G4GDMLReadSolids::~G4GDMLReadSolids()
+{
+}
 
 void G4GDMLReadSolids::
@@ -1478,5 +1519,5 @@
 
 void G4GDMLReadSolids::
-OpticalsurfaceRead(const xercesc::DOMElement* const opticalsurfaceElement)
+OpticalSurfaceRead(const xercesc::DOMElement* const opticalsurfaceElement)
 {
    G4String name;
@@ -1514,5 +1555,7 @@
    G4SurfaceType type;   
    
-   if (smodel="unified") { model = unified; } else { model = glisur; }
+   if (smodel="unified") { model = unified; } else
+   if (smodel="glisur") { model = glisur; }
+   else { model = LUT; }
 
    if (sfinish=="polishedfrontpainted") { finish = polishedfrontpainted; } else
@@ -1520,9 +1563,36 @@
    if (sfinish=="groundfrontpainted") { finish = groundfrontpainted; } else
    if (sfinish=="groundbackpainted") { finish = groundbackpainted; } else
-   if (sfinish=="ground") { finish = ground; } else { finish = polished; }
+   if (sfinish=="ground") { finish = ground; } else
+   if (sfinish=="polished") { finish = polished; } else
+   if (sfinish=="polishedlumirrorair") { finish = polishedlumirrorair; } else
+   if (sfinish=="polishedlumirrorglue") { finish = polishedlumirrorglue; } else
+   if (sfinish=="polishedair") { finish = polishedair; } else
+   if (sfinish=="polishedteflonair") { finish = polishedteflonair; } else
+   if (sfinish=="polishedtioair") { finish = polishedtioair; } else
+   if (sfinish=="polishedtyvekair") { finish = polishedtyvekair; } else
+   if (sfinish=="polishedvm2000air") { finish = polishedvm2000air; } else
+   if (sfinish=="polishedvm2000glue") { finish = polishedvm2000glue; } else
+   if (sfinish=="etchedlumirrorair") { finish = etchedlumirrorair; } else
+   if (sfinish=="etchedlumirrorglue") { finish = etchedlumirrorglue; } else
+   if (sfinish=="etchedair") { finish = etchedair; } else
+   if (sfinish=="etchedteflonair") { finish = etchedteflonair; } else
+   if (sfinish=="etchedtioair") { finish = etchedtioair; } else
+   if (sfinish=="etchedtyvekair") { finish = etchedtyvekair; } else
+   if (sfinish=="etchedvm2000air") { finish = etchedvm2000air; } else
+   if (sfinish=="etchedvm2000glue") { finish = etchedvm2000glue; } else
+   if (sfinish=="groundlumirrorair") { finish = groundlumirrorair; } else
+   if (sfinish=="groundlumirrorglue") { finish = groundlumirrorglue; } else
+   if (sfinish=="groundair") { finish = groundair; } else
+   if (sfinish=="groundteflonair") { finish = groundteflonair; } else
+   if (sfinish=="groundtioair") { finish = groundtioair; } else
+   if (sfinish=="groundtyvekair") { finish = groundtyvekair; } else
+   if (sfinish=="groundvm2000air") { finish = groundvm2000air; }
+   else { finish = groundvm2000glue; }
 
    if (stype=="dielectric_metal") { type = dielectric_metal; } else
-   if (stype=="x_ray") { type = x_ray; } else
-   if (stype=="firsov") { type = firsov; } else { type = dielectric_dielectric; }
+   if (stype=="dielectric_dielectric") { type = dielectric_dielectric; } else
+   if (stype=="dielectric_LUT") { type = dielectric_LUT; } else
+   if (stype=="x_ray") { type = x_ray; }
+   else { type = firsov; }
 
    new G4OpticalSurface(name,model,finish,type,value);
@@ -1541,7 +1611,7 @@
             = dynamic_cast<xercesc::DOMElement*>(iter);
       const G4String tag = Transcode(child->getTagName());
-
-      if (tag=="box") { BoxRead(child); } else
-      if (tag=="cone") { ConeRead(child); } else
+      if (tag=="define") { DefineRead(child);  }  else 
+      if (tag=="box")    { BoxRead(child); } else
+      if (tag=="cone")   { ConeRead(child); } else
       if (tag=="elcone") { ElconeRead(child); } else
       if (tag=="ellipsoid") { EllipsoidRead(child); }else
@@ -1569,5 +1639,5 @@
       if (tag=="twistedtubs") { TwistedtubsRead(child); } else
       if (tag=="union") { BooleanRead(child,UNION); } else
-      if (tag=="opticalsurface") { OpticalsurfaceRead(child); } else
+      if (tag=="opticalsurface") { OpticalSurfaceRead(child); } else
       if (tag=="loop") { LoopRead(child,&G4GDMLRead::SolidsRead); }
       else
